Index: src/backend/commands/copy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/copy.c,v
retrieving revision 1.245
diff -c -r1.245 copy.c
*** src/backend/commands/copy.c	2 Jun 2005 01:21:22 -0000	1.245
--- src/backend/commands/copy.c	27 Jun 2005 18:45:39 -0000
***************
*** 2203,2209 ****
  					(eol_type == EOL_CR && c != '\r'))
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 							 errmsg("end-of-copy marker does not match previous newline style")));
  
  				/*
  				 * In protocol version 3, we should ignore anything after
--- 3055,3062 ----
  					(eol_type == EOL_CR && c != '\r'))
  					ereport(ERROR,
  							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 							 errmsg
! 							 ("end-of-copy marker does not match previous newline style")));
  
  				/*
  				 * In protocol version 3, we should ignore anything after
***************
*** 2218,2228 ****
  				result = true;	/* report EOF */
  				break;
  			}
! 			
  			if (csv_mode)
! 				CopyDonePeek(c2, false); /* not a dot, so put it back */ 
  			else
! 				/* not EOF mark, so emit \ and following char literally */
  				appendStringInfoCharMacro(&line_buf, '\\');
  		}
  
--- 3071,3083 ----
  				result = true;	/* report EOF */
  				break;
  			}
! 
  			if (csv_mode)
! 				CopyDonePeek(c2, false);		/* not a dot, so put it back */
  			else
! 				/*
! 				 * not EOF mark, so emit \ and following char literally
! 				 */
  				appendStringInfoCharMacro(&line_buf, '\\');
  		}
  
***************
*** 2254,2290 ****
  		}
  	}							/* end of outer loop */
  
! 	/* Done reading the line.  Convert it to server encoding. */
! 	if (change_encoding)
  	{
! 		cvt = (char *) pg_client_to_server((unsigned char *) line_buf.data,
! 										   line_buf.len);
! 		if (cvt != line_buf.data)
! 		{
! 			/* transfer converted data back to line_buf */
! 			line_buf.len = 0;
! 			line_buf.data[0] = '\0';
! 			appendBinaryStringInfo(&line_buf, cvt, strlen(cvt));
! 		}
  	}
  
! 	/* Now it's safe to use the buffer in error messages */
! 	line_buf_converted = true;
! 
! 	return result;
  }
  
- /*
-  *	Return decimal value for a hexadecimal digit
-  */
- static
- int GetDecimalFromHex(char hex)
- {
- 	if (isdigit(hex))
- 		return hex - '0';
- 	else
- 		return tolower(hex) - 'a' + 10;
- }
  
  /*----------
   * Read the value of a single attribute, performing de-escaping as needed.
--- 3109,3502 ----
  		}
  	}							/* end of outer loop */
  
! 	/*
! 	 * Done reading the line.  Convert it to server encoding.
! 	 */
! 	if (change_encoding)
! 	{
! 		cvt = (char *) pg_client_to_server((unsigned char *) line_buf.data,
! 										   line_buf.len);
! 		if (cvt != line_buf.data)
! 		{
! 			/*
! 			 * transfer converted data back to line_buf
! 			 */
! 			line_buf.len = 0;
! 			line_buf.data[0] = '\0';
! 			line_buf.cursor = 0;
! 			appendBinaryStringInfo(&line_buf, cvt, strlen(cvt));
! 		}
! 	}
! 
! 	/*
! 	 * Now it's safe to use the buffer in error messages 
! 	 */
! 	line_buf_converted = true;
! 
! 	return result;
! }
! 
! /*
!  *	Return decimal value for a hexadecimal digit
!  */
! static int
! GetDecimalFromHex(char hex)
! {
! 	if (isdigit(hex))
! 		return hex - '0';
! 	else
! 		return tolower(hex) - 'a' + 10;
! }
! 
! /*
!  * Detected the eol type by looking at the first data row.
!  * Possible eol types are NL, CR, or CRNL. If eol type was
!  * detected, it is set and a boolean true is returned to
!  * indicated detection was successful. If the first data row
!  * is longer than the input buffer, we return false and will
!  * try again in the next buffer.
!  */
! static bool
! DetectLineEnd(size_t bytesread)
! {
! 	int			bytes_remaining = COPY_BUF_SIZE;
! 	char		ch_found;		/* the character found in the scan ('\n' or '\r' or escapec) */
! 	char	   *start = input_buf;
! 	char	   *end;
! 
! 	while (true)
! 	{
! 		bytes_remaining = COPY_BUF_SIZE - (input_buf - start);
! 
! 		if (bytes_remaining <= 0)
! 			return false;
! 
! 		if ((end =
! 			 str2chrlen(start, '\n', '\r', bytes_remaining,
! 						&ch_found)) == NULL)
! 		{
! 			return false;
! 		}
! 		else
! 		{
! 			if (ch_found == '\n')
! 			{
! 				eol_type = EOL_NL;
! 				eol_ch[0] = '\n';
! 				eol_ch[1] = '\0';
! 
! 				return true;
! 			}
! 			if (ch_found == '\r')
! 			{
! 				if (*(end + 1) == '\n')
! 				{
! 					eol_type = EOL_CRNL;
! 					eol_ch[0] = '\r';
! 					eol_ch[1] = '\n';
! 				}
! 				else
! 				{
! 					eol_type = EOL_CR;
! 					eol_ch[0] = '\r';
! 					eol_ch[1] = '\0';
! 				}
! 
! 				return true;
! 			}
! 		}
! 	}
! 
! }
! 
! 
! /*
!  * Finds the next data line that is in the input buffer and loads it into line_buf.
!  * Returns an indication if the line that was read is complete (if an unescaped line-end was
!  * encountered). If we reached the end of buffer before the whole line was written into the
!  * line buffer then returns false.
!  */
! static bool
! CopyReadLineBuffered(size_t bytesread)
! {
! 	int			linesize;
! 	bool		transcode = (client_encoding != server_encoding);
! 	char	   *cvt;
! 	bool		end_marker;
! 
! 	/*
! 	 * mark that encoding conversion hasn't occurred yet 
! 	 */
! 	line_buf_converted = false;
! 
! 	/*
! 	 * Detect end of line type if not already detected.
! 	 */
! 	if (eol_type == EOL_UNKNOWN)
! 	{
! 		bool		eol_detected = DetectLineEnd(bytesread);
! 
! 		if (!eol_detected)
! 		{
! 			/*
! 			 * load entire input buffer into line buf, and quit
! 			 */
! 			appendBinaryStringInfo(&line_buf, input_buf, COPY_BUF_SIZE);
! 			line_done = false;
! 			buf_done = true;
! 
! 			return line_done;
! 		}
! 	}
! 
! 	/*
! 	 * Special case: eol is CRNL, last byte of previous buffer was an
! 	 * unescaped CR and 1st byte of current buffer is NL. We check for
! 	 * that here.
! 	 */
! 	if (eol_type == EOL_CRNL)
! 	{
! 		/*
! 		 * if we started scanning from the 1st byte of the buffer
! 		 */
! 		if (begloc == input_buf)
! 		{
! 			/*
! 			 * and had a CR in last byte of prev buf
! 			 */
! 			if (cr_in_prevbuf)
! 			{
! 				/*
! 				 * if this 1st byte in buffer is 2nd byte of line end sequence (linefeed)
! 				 */
! 				if (*begloc == eol_ch[1])
! 				{
! 					/*
! 					 * load that one linefeed byte and indicate we are done with the data line
! 					 */
! 					appendBinaryStringInfo(&line_buf, begloc, 1);
! 					buffer_index++;
! 					begloc++;
! 
! 					line_done = true;
! 					esc_in_prevbuf = false;
! 					cr_in_prevbuf = false;
! 
! 					return line_done;
! 				}
! 			}
! 
! 			cr_in_prevbuf = false;
! 		}
! 	}
! 
! 	/*
! 	 * (we need a loop so that if eol_ch is found, but prev ch is backslash, we can search
! 	 * for the next eol_ch)
! 	 */
! 	while (true)
! 	{
! 		/*
! 		 * reached end of buffer
! 		 */
! 		if ((endloc =
! 			 strchrlen(begloc, eol_ch[0], bytesread - buffer_index)) == NULL)
! 		{
! 			linesize = COPY_BUF_SIZE - (begloc - input_buf);
! 			appendBinaryStringInfo(&line_buf, begloc, linesize);
! 
! 			if (line_buf.len > 1)
! 			{
! 				char	   *last_ch = line_buf.data + line_buf.len - 1; /* before terminating \0 */
! 
! 				if (*last_ch == escapec)
! 				{
! 					esc_in_prevbuf = true;
! 
! 					if (line_buf.len > 2)
! 					{
! 						last_ch--;
! 						if (*last_ch == escapec)
! 							esc_in_prevbuf = false;
! 					}
! 				}
! 				else if (*last_ch == '\r')
! 				{
! 					if (eol_type == EOL_CRNL)
! 						cr_in_prevbuf = true;
! 				}
! 			}
! 
! 			line_done = false;
! 			buf_done = true;
! 			break;
! 		}
! 		else
! 			/*
! 			 * found the 1st eol ch in input_buf.
! 			 */
! 		{
! 			bool		eol_found = true;
! 			bool		eol_escaped = true;
! 
! 			/*
! 			 * Load that piece of data (potentially a data line) into the line buffer,
! 			 * and update the pointers for the next scan.
! 			 */
! 			linesize = endloc - begloc + 1;
! 			appendBinaryStringInfo(&line_buf, begloc, linesize);
! 			buffer_index += linesize;
! 			begloc = endloc + 1;
! 
! 			if (eol_type == EOL_CRNL)
! 			{
! 				/*
! 				 * check if there is a '\n' after the '\r'
! 				 */
! 				if (*(endloc + 1) == '\n')
! 				{
! 					/*
! 					 * this is a line end
! 					 */
! 					appendBinaryStringInfo(&line_buf, begloc, 1);		/* load that '\n' */
! 					buffer_index++;
! 					begloc++;
! 				}
! 				else
! 					/*
! 					 * just a CR, not a line end
! 					 */
! 					eol_found = false;
! 			}
! 
! 			/*
! 			 * in some cases, this end of line char happens to be the
! 			 * last character in the buffer. we need to catch that.
! 			 */
! 			if (buffer_index >= bytesread)
! 				buf_done = true;
! 
! 			/*
! 			 * Check if the 1st end of line ch is escaped.
! 			 */
! 			if (endloc != input_buf)	/* can we look 1 char back? */
! 			{
! 				if (*(endloc - 1) != escapec)	/* prev char is not an escape */
! 					eol_escaped = false;
! 				else
! 					/*
! 					 * prev char is an escape
! 					 */
! 				{
! 					if (endloc != (input_buf + 1))		/* can we look another char back? */
! 					{
! 						/*
! 						 * it's a double escape char, so it's not an escape
! 						 */
! 						if (*(endloc - 2) == escapec)
! 							eol_escaped = false;
! 						/*
! 						 * else it's a single escape char, so EOL is ascaped 
! 						 */
! 					}
! 					else
! 					{
! 						/*
! 						 * we need to check in the last buffer
! 						 */
! 						if (esc_in_prevbuf)		/* double escape char, so not an escape */
! 							eol_escaped = false;
! 					}
! 				}
! 			}
! 			else
! 				/*
! 				 * this eol ch is first ch in buffer, check for escape in prev buf
! 				 */
! 			{
! 				if (!esc_in_prevbuf)
! 					eol_escaped = false;
! 			}
! 
! 			esc_in_prevbuf = false;		/* reset variable */
! 
! 			/*
! 			 * if eol was found, and it isn't escaped, line is done
! 			 */
! 			if ((eol_escaped == false) && eol_found)
! 			{
! 				line_done = true;
! 				break;
! 			}
! 			else
! 				/*
! 				 * stay in the loop and process some more data.
! 				 */
! 				line_done = false;
! 
! 		}						/* end of found eol_ch */
! 	}
! 
! 	/*
! 	 * Done reading the line. Convert it to server encoding.
! 	 */
! 	if (transcode)
! 	{
! 		cvt = (char *) pg_client_to_server((unsigned char *) line_buf.data,
! 										   line_buf.len);
! 		if (cvt != line_buf.data)
! 		{
! 			/*
! 			 * transfer converted data back to line_buf
! 			 */
! 			line_buf.len = 0;
! 			line_buf.data[0] = '\0';
! 			line_buf.cursor = 0;
! 			appendBinaryStringInfo(&line_buf, cvt, strlen(cvt));
! 		}
! 	}
! 
! 	/*
! 	 * indicate that conversion had occured
! 	 */
! 	line_buf_converted = true;
! 
! 	/*
! 	 * check if this line is an end marker -- "\."
! 	 */
! 	end_marker = false;
! 
! 	switch (eol_type)
! 	{
! 		case EOL_NL:
! 			if (!strcmp(line_buf.data, "\\.\n"))
! 				end_marker = true;
! 			break;
! 		case EOL_CR:
! 			if (!strcmp(line_buf.data, "\\.\r"))
! 				end_marker = true;
! 			break;
! 		case EOL_CRNL:
! 			if (!strcmp(line_buf.data, "\\.\r\n"))
! 				end_marker = true;
! 			break;
! 		case EOL_UNKNOWN:
! 			break;
! 	}
! 
! 	if (end_marker)
  	{
! 		fe_eof = true;
! 		/*
! 		 * we don't want to process a \. as data line, want to quit. 
! 		 */
! 		line_done = false;
! 		buf_done = true;
  	}
  
! 	return line_done;
  }
  
  
  /*----------
   * Read the value of a single attribute, performing de-escaping as needed.
***************
*** 2314,2324 ****
  	int			end_cursor;
  	int			input_len;
  
! 	/* reset attribute_buf to empty */
! 	attribute_buf.len = 0;
! 	attribute_buf.data[0] = '\0';
  
! 	/* set default status */
  	*result = END_OF_LINE;
  
  	for (;;)
--- 3526,3541 ----
  	int			end_cursor;
  	int			input_len;
  
! 	/*
! 	 * reset attr_buf to empty
! 	 */
! 	attr_buf.len = 0;
! 	attr_buf.data[0] = '\0';
! 	attr_buf.cursor = 0;
  
! 	/*
! 	 * set default status
! 	 */
  	*result = END_OF_LINE;
  
  	for (;;)
***************
*** 2347,2353 ****
  				case '5':
  				case '6':
  				case '7':
! 					/* handle \013 */
  					{
  						int			val;
  
--- 3564,3572 ----
  				case '5':
  				case '6':
  				case '7':
! 					/*
! 					 * handle \013
! 					 */
  					{
  						int			val;
  
***************
*** 2374,2387 ****
  					}
  					break;
  				case 'x':
! 					/* Handle \x3F */
  					if (line_buf.cursor < line_buf.len)
  					{
! 						char hexchar = line_buf.data[line_buf.cursor];
  
  						if (isxdigit(hexchar))
  						{
! 							int val = GetDecimalFromHex(hexchar);
  
  							line_buf.cursor++;
  							if (line_buf.cursor < line_buf.len)
--- 3593,3608 ----
  					}
  					break;
  				case 'x':
! 					/*
! 					 * Handle \x3F
! 					 */
  					if (line_buf.cursor < line_buf.len)
  					{
! 						char		hexchar = line_buf.data[line_buf.cursor];
  
  						if (isxdigit(hexchar))
  						{
! 							int			val = GetDecimalFromHex(hexchar);
  
  							line_buf.cursor++;
  							if (line_buf.cursor < line_buf.len)
***************
*** 2390,2396 ****
  								if (isxdigit(hexchar))
  								{
  									line_buf.cursor++;
! 									val = (val << 4) + GetDecimalFromHex(hexchar);
  								}
  							}
  							c = val & 0xff;
--- 3611,3619 ----
  								if (isxdigit(hexchar))
  								{
  									line_buf.cursor++;
! 									val =
! 										(val << 4) +
! 										GetDecimalFromHex(hexchar);
  								}
  							}
  							c = val & 0xff;
***************
*** 2422,2431 ****
  					 */
  			}
  		}
! 		appendStringInfoCharMacro(&attribute_buf, c);
  	}
  
! 	/* check whether raw input matched null marker */
  	input_len = end_cursor - start_cursor;
  	if (input_len == strlen(null_print) &&
  		strncmp(&line_buf.data[start_cursor], null_print, input_len) == 0)
--- 3645,3656 ----
  					 */
  			}
  		}
! 		appendStringInfoCharMacro(&attr_buf, c);
  	}
  
! 	/*
! 	 * check whether raw input matched null marker
! 	 */
  	input_len = end_cursor - start_cursor;
  	if (input_len == strlen(null_print) &&
  		strncmp(&line_buf.data[start_cursor], null_print, input_len) == 0)
***************
*** 2433,2439 ****
  	else
  		*isnull = false;
  
! 	return attribute_buf.data;
  }
  
  
--- 3658,4066 ----
  	else
  		*isnull = false;
  
! 	return attr_buf.data;
! }
! 
! /*
!  * Read the first attribute. This is mainly used to maintain support
!  * for an OID column. All the rest of the columns will be read at once with
!  * CopyReadAllAttrs().
!  */
! static char *
! CopyReadOidAttr(const char *delim, const char *null_print, int null_print_len,
! 				CopyReadResult *result, bool *isnull)
! {
! 	char		delimc = delim[0];
! 	char	   *start_loc = line_buf.data + line_buf.cursor;
! 	char	   *end_loc;
! 	int			attr_len = 0;
! 	int			bytes_remaining;
! 
! 	/*
! 	 * reset attribute buf to empty
! 	 */
! 	attr_buf.len = 0;
! 	attr_buf.data[0] = '\0';
! 	attr_buf.cursor = 0;
! 
! 	/*
! 	 * set default status
! 	 */
! 	*result = END_OF_LINE;
! 
! 	/*
! 	 * # of bytes that were not yet processed in this line
! 	 */
! 	bytes_remaining = line_buf.len - line_buf.cursor;
! 
! 	/*
! 	 * got to end of line
! 	 */
! 	if ((end_loc = strchrlen(start_loc, delimc, bytes_remaining)) == NULL)
! 	{
! 		attr_len = bytes_remaining - 1; /* don't count '\n' in len calculation */
! 		appendBinaryStringInfo(&attr_buf, start_loc, attr_len);
! 		line_buf.cursor += attr_len + 2;		/* skip '\n' and '\0' */
! 
! 		*result = END_OF_LINE;
! 	}
! 	else
! 		/*
! 		 * found a delimiter
! 		 */
! 	{
! 		/*
! 		 * (we don't care if delim was preceded with a backslash, because it's an
! 		 * invalid OID anyway)
! 		 */
! 
! 		attr_len = end_loc - start_loc; /* we don't include the delimiter ch */
! 
! 		appendBinaryStringInfo(&attr_buf, start_loc, attr_len);
! 		line_buf.cursor += attr_len + 1;
! 
! 		*result = NORMAL_ATTR;
! 	}
! 
! 
! 	/*
! 	 * check whether raw input matched null marker
! 	 */
! 	if (attr_len == null_print_len
! 		&& strncmp(start_loc, null_print, attr_len) == 0)
! 		*isnull = true;
! 	else
! 		*isnull = false;
! 
! 	return attr_buf.data;
! }
! 
! 
! /*
!  * Read all attributes. Attributes are parsed from line_buf and
!  * inserted (all at once) to attr_buf, while saving pointers to
!  * each attribute's starting position.
!  *
!  * When this routine finishes execution both the nulls array and
!  * the attr_offsets array are updated. The attr_offsets will include
!  * the offset from the beginning of the attribute array of which
!  * each attribute begins. If a specific attribute is not used for this
!  * COPY command (ommitted from the column list), a value of 0 will be assigned.
!  * For example: for table foo(a,b,c,d,e) and COPY foo(a,b,e)
!  * attr_offsets may look something like this after this routine
!  * returns: [0,20,0,0,55]. That means that column "a" value starts
!  * at byte offset 0, "b" in 20 and "e" in 55, in attr_buf.
!  *
!  * In the attribute buffer (attr_buf) each attribute
!  * is terminated with a '\0', and therefore by using the attr_offsets
!  * array we could point to a beginning of an attribute and have it
!  * behave as a C string, much like previously done in COPY.
!  *
!  * Another aspect to improving performance is reducing the frequency
!  * of data load into buffers. The original COPY read attribute code
!  * loaded a character at a time. In here we try to load a chunk of data
!  * at a time. Usually a chunk will include a full data row
!  * (unless we have an escaped delim). That effectively reduces the number of
!  * loads by a factor of number of bytes per row. This improves performance
!  * greatly, unfortunately it add more complexity to the code.
!  *
!  * Global participants in parsing logic:
!  *
!  * line_buf.cursor -- an offset from beginning of the line buffer
!  * that indicates where we are about to begin the next scan. Note that
!  * if we have WITH OIDS this cursor is already shifted past the first
!  * OID attribute.
!  *
!  * attr_buf.cursor -- an offset from the beginning of the
!  * attribute buffer that indicates where the current attribute begins.
!  */
! static void
! CopyReadAllAttrs(const char *delim, const char *null_print, int null_print_len,
! 				 char *nulls, List *attnumlist, int *attr_offsets,
! 				 int num_phys_attrs, Form_pg_attribute *attr)
! {
! 	char		delimc = delim[0];		/* delimiter character */
! 	char	   *scan_start;		/* pointer to line buffer where scan should start. */
! 	char	   *scan_end;		/* pointer to line buffer where char was found */
! 	char		ch_found;		/* the character found in the scan (delimc or escape) */
! 	int			attr_pre_len;	/* current attr raw len, before processing escapes */
! 	int			attr_post_len;	/* current attr len after escaping */
! 	int			m;				/* attribute index being parsed */
! 	int			bytes_remaining;		/* num of bytes remaining to be scanned in line buf */
! 	int			chunk_start;	/* offset to beginning of line chunk to load */
! 	int			chunk_len;		/* length of chunk of data to load to attr buf */
! 	int			oct_val;		/* byte value for octal escapes */
! 	int			attnum;			/* attribute number being parsed */
! 	ListCell   *cur;			/* cursor to attribute list used for this COPY */
! 	int			attribute;
! 
! 	/*
! 	 * init variables for attribute scan
! 	 */
! 	attr_buf.len = 0;
! 	attr_buf.data[0] = '\0';
! 	attr_buf.cursor = 0;
! 	/*
! 	 * cursor is now > 0 if we copy WITH OIDS
! 	 */
! 	scan_start = line_buf.data + line_buf.cursor;
! 	cur = list_head(attnumlist);
! 	attnum = lfirst_int(cur);
! 	m = attnum - 1;
! 	chunk_start = line_buf.cursor;
! 	chunk_len = 0;
! 	attr_pre_len = 0;
! 	attr_post_len = 0;
! 
! 	/*
! 	 * Scan through the line buffer to read all attributes data
! 	 */
! 	while (line_buf.cursor < line_buf.len)
! 	{
! 		bytes_remaining = line_buf.len - line_buf.cursor;
! 		ch_found = '\0';
! 
! 		if ((scan_end =
! 			 str2chrlen(scan_start, delimc, escapec, bytes_remaining,
! 						&ch_found)) == NULL)
! 		{
! 			/*
! 			 * GOT TO END OF LINE BUFFER
! 			 */
! 
! 			if (cur == NULL)
! 				ereport(ERROR,
! 						(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 						 errmsg("extra data after last expected column")));
! 
! 			attnum = lfirst_int(cur);
! 			m = attnum - 1;
! 
! 			/*
! 			 * don't count eol char(s) in attr and chunk len calculation 
! 			 */
! 			if (eol_type == EOL_CRNL)
! 			{
! 				attr_pre_len += bytes_remaining - 2;
! 				chunk_len = line_buf.len - chunk_start - 2;
! 			}
! 			else
! 			{
! 				attr_pre_len += bytes_remaining - 1;
! 				chunk_len = line_buf.len - chunk_start - 1;
! 			}
! 
! 			/*
! 			 * check if this is a NULL value or data value (assumed NULL)
! 			 */
! 			if (attr_pre_len == null_print_len
! 				&&
! 				strncmp(line_buf.data + line_buf.len - attr_pre_len - 1,
! 						null_print, attr_pre_len) == 0)
! 				nulls[m] = 'n';
! 			else
! 				nulls[m] = ' ';
! 
! 			attr_offsets[m] = attr_buf.cursor;
! 
! 
! 			/*
! 			 * load the last chunk, the whole buffer in most cases
! 			 */
! 			appendBinaryStringInfo(&attr_buf, line_buf.data + chunk_start,
! 								   chunk_len);
! 
! 			line_buf.cursor += attr_pre_len + 2;		/* skip eol char and '\0' to exit loop */
! 
! 			if (lnext(cur) != NULL)
! 			{
! 				/*
! 				 * For an empty data line, the previous COPY code will
! 				 * fail it during the conversion stage. We can fail it here
! 				 * already, but then we will fail the regression tests b/c
! 				 * of a different error message. that's why we return so we
! 				 * can get the same error message that regress expects. ahh...
! 				 * this conditional is unnecessary and should be removed soon.
! 				 */
! 				if (line_buf.len > 1)
! 					ereport(ERROR,
! 							(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 							 errmsg("missing data for column \"%s\"",
! 									NameStr(attr[m + 1]->attname))));
! 				else
! 					return;
! 			}
! 		}
! 		else
! 			/*
! 			 * FOUND A DELIMITER OR ESCAPE
! 			 */
! 		{
! 			if (cur == NULL)
! 				ereport(ERROR,
! 						(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
! 						 errmsg("extra data after last expected column")));
! 
! 			if (ch_found == delimc)		/* found a delimiter */
! 			{
! 				attnum = lfirst_int(cur);
! 				m = attnum - 1;
! 
! 				/*
! 				 * (we don't include the delimiter ch in length) 
! 				 */
! 				attr_pre_len += scan_end - scan_start;
! 				/*
! 				 * (we don't include the delimiter ch in length) 
! 				 */
! 				attr_post_len += scan_end - scan_start;
! 
! 				/*
! 				 * check if this is a null print or data (assumed NULL)
! 				 */
! 				if (attr_pre_len == null_print_len
! 					&&
! 					strncmp(scan_end - attr_pre_len, null_print, attr_pre_len)
! 					== 0)
! 					nulls[m] = 'n';
! 				else
! 					nulls[m] = ' ';
! 
! 				/*
! 				 * set the pointer to next attribute position
! 				 */
! 				attr_offsets[m] = attr_buf.cursor;
! 
! 				/*
! 				 * update buffer cursors to our current location, +1 to skip the delimc
! 				 */
! 				line_buf.cursor = scan_end - line_buf.data + 1;
! 				attr_buf.cursor += attr_post_len + 1;
! 
! 				/*
! 				 * prepare scan for next attr
! 				 */
! 				scan_start = line_buf.data + line_buf.cursor;
! 				cur = lnext(cur);
! 				attr_pre_len = 0;
! 				attr_post_len = 0;
! 			}
! 			else
! 				/*
! 				 * found an escape character
! 				 */
! 			{
! 				char		nextc = *(scan_end + 1);
! 				char		newc;
! 				int			skip = 2;
! 
! 				chunk_len = (scan_end - line_buf.data) - chunk_start + 1;
! 
! 				/*
! 				 * load a chunk of data
! 				 */
! 				appendBinaryStringInfo(&attr_buf, line_buf.data + chunk_start,
! 									   chunk_len);
! 
! 				switch (nextc)
! 				{
! 					case '0':
! 					case '1':
! 					case '2':
! 					case '3':
! 					case '4':
! 					case '5':
! 					case '6':
! 					case '7':
! 						oct_val = OCTVALUE(nextc);
! 						nextc = *(scan_end + 2);
! 						/*
! 						 * (no need for out bad access check since line if buffered)
! 						 */
! 						if (ISOCTAL(nextc))
! 						{
! 							skip++;
! 							oct_val = (oct_val << 3) + OCTVALUE(nextc);
! 							nextc = *(scan_end + 3);
! 							if (ISOCTAL(nextc))
! 							{
! 								skip++;
! 								oct_val = (oct_val << 3) + OCTVALUE(nextc);
! 							}
! 						}
! 						newc = oct_val & 0377;	/* the escaped byte value */
! 						break;
! 					case 'b':
! 						newc = '\b';
! 						break;
! 					case 'f':
! 						newc = '\f';
! 						break;
! 					case 'n':
! 						newc = '\n';
! 						break;
! 					case 'r':
! 						newc = '\r';
! 						break;
! 					case 't':
! 						newc = '\t';
! 						break;
! 					case 'v':
! 						newc = '\v';
! 						break;
! 					default:
! 						if (nextc == delimc)
! 							newc = delimc;
! 						else if (nextc == escapec)
! 							newc = escapec;
! 						else
! 							/*
! 							 * no escape sequence, take next char literaly
! 							 */
! 							newc = nextc;
! 						break;
! 				}
! 
! 				/*
! 				 * update to current length, add escape and escaped chars
! 				 */
! 				attr_pre_len += scan_end - scan_start + 2;
! 				/*
! 				 * update to current length, escaped char
! 				 */
! 				attr_post_len += scan_end - scan_start + 1;
! 
! 				/*
! 				 * Need to get rid of the escape character. This is done by
! 				 * loading the chunk up to including the escape character
! 				 * into the attribute buffer. Then overwritting the backslash
! 				 * with the escaped sequence or char, and continuing to scan
! 				 * from *after* the char than is after the escape in line buf.
! 				 */
! 				*(attr_buf.data + attr_buf.len - 1) = newc;
! 				line_buf.cursor = scan_end - line_buf.data + skip;
! 				scan_start = scan_end + skip;
! 				chunk_start = line_buf.cursor;
! 				chunk_len = 0;
! 			}
! 
! 		}						/* end delimiter/backslash */
! 
! 	}							/* end line buffer scan. */
! 
! 	/*
! 	 * Replace all delimiters with NULL for string termination.
! 	 * NOTE: only delimiters (NOT necessarily all delimc) are replaced.
! 	 * Example (delimc = '|'):
! 	 * - Before:  f  1	|  f  \|  2  |	f  3
! 	 * - After :  f  1 \0  f   |  2 \0	f  3
! 	 */
! 	for (attribute = 1; attribute < num_phys_attrs; attribute++)
! 	{
! 		if (attr_offsets[attribute] != 0)
! 			*(attr_buf.data + attr_offsets[attribute] - 1) = '\0';
! 	}
! 
  }
  
  
***************
*** 2477,2487 ****
  	bool		in_quote = false;
  	bool		saw_quote = false;
  
! 	/* reset attribute_buf to empty */
! 	attribute_buf.len = 0;
! 	attribute_buf.data[0] = '\0';
  
! 	/* set default status */
  	*result = END_OF_LINE;
  
  	for (;;)
--- 4104,4119 ----
  	bool		in_quote = false;
  	bool		saw_quote = false;
  
! 	/*
! 	 * reset attr_buf to empty
! 	 */
! 	attr_buf.len = 0;
! 	attr_buf.data[0] = '\0';
! 	attr_buf.cursor = 0;
  
! 	/*
! 	 * set default status
! 	 */
  	*result = END_OF_LINE;
  
  	for (;;)
***************
*** 2491,2504 ****
  			break;
  		c = line_buf.data[line_buf.cursor++];
  
! 		/* unquoted field delimiter  */
  		if (!in_quote && c == delimc)
  		{
  			*result = NORMAL_ATTR;
  			break;
  		}
  
! 		/* start of quoted field (or part of field) */
  		if (!in_quote && c == quotec)
  		{
  			saw_quote = true;
--- 4123,4140 ----
  			break;
  		c = line_buf.data[line_buf.cursor++];
  
! 		/*
! 		 * unquoted field delimiter
! 		 */
  		if (!in_quote && c == delimc)
  		{
  			*result = NORMAL_ATTR;
  			break;
  		}
  
! 		/*
! 		 * start of quoted field (or part of field)
! 		 */
  		if (!in_quote && c == quotec)
  		{
  			saw_quote = true;
***************
*** 2506,2512 ****
  			continue;
  		}
  
! 		/* escape within a quoted field */
  		if (in_quote && c == escapec)
  		{
  			/*
--- 4142,4150 ----
  			continue;
  		}
  
! 		/*
! 		 * escape within a quoted field
! 		 */
  		if (in_quote && c == escapec)
  		{
  			/*
***************
*** 2519,2525 ****
  
  				if (nextc == escapec || nextc == quotec)
  				{
! 					appendStringInfoCharMacro(&attribute_buf, nextc);
  					line_buf.cursor++;
  					continue;
  				}
--- 4157,4163 ----
  
  				if (nextc == escapec || nextc == quotec)
  				{
! 					appendStringInfoCharMacro(&attr_buf, nextc);
  					line_buf.cursor++;
  					continue;
  				}
***************
*** 2536,2548 ****
  			in_quote = false;
  			continue;
  		}
! 		appendStringInfoCharMacro(&attribute_buf, c);
  	}
  
  	if (in_quote)
  		*result = UNTERMINATED_FIELD;
  
! 	/* check whether raw input matched null marker */
  	input_len = end_cursor - start_cursor;
  	if (!saw_quote && input_len == strlen(null_print) &&
  		strncmp(&line_buf.data[start_cursor], null_print, input_len) == 0)
--- 4174,4188 ----
  			in_quote = false;
  			continue;
  		}
! 		appendStringInfoCharMacro(&attr_buf, c);
  	}
  
  	if (in_quote)
  		*result = UNTERMINATED_FIELD;
  
! 	/*
! 	 * check whether raw input matched null marker
! 	 */
  	input_len = end_cursor - start_cursor;
  	if (!saw_quote && input_len == strlen(null_print) &&
  		strncmp(&line_buf.data[start_cursor], null_print, input_len) == 0)
***************
*** 2550,2556 ****
  	else
  		*isnull = false;
  
! 	return attribute_buf.data;
  }
  
  /*
--- 4190,4196 ----
  	else
  		*isnull = false;
  
! 	return attr_buf.data;
  }
  
  /*
***************
*** 2578,2606 ****
  				(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  				 errmsg("invalid field size")));
  
! 	/* reset attribute_buf to empty, and load raw data in it */
! 	attribute_buf.len = 0;
! 	attribute_buf.data[0] = '\0';
! 	attribute_buf.cursor = 0;
  
! 	enlargeStringInfo(&attribute_buf, fld_size);
  
! 	CopyGetData(attribute_buf.data, fld_size);
  	if (CopyGetEof())
  		ereport(ERROR,
  				(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  				 errmsg("unexpected EOF in COPY data")));
  
! 	attribute_buf.len = fld_size;
! 	attribute_buf.data[fld_size] = '\0';
  
! 	/* Call the column type's binary input converter */
  	result = FunctionCall2(flinfo,
! 						   PointerGetDatum(&attribute_buf),
  						   ObjectIdGetDatum(typioparam));
  
! 	/* Trouble if it didn't eat the whole buffer */
! 	if (attribute_buf.cursor != attribute_buf.len)
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
  				 errmsg("incorrect binary data format")));
--- 4218,4252 ----
  				(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  				 errmsg("invalid field size")));
  
! 	/*
! 	 * reset attr_buf to empty, and load raw data in it
! 	 */
! 	attr_buf.len = 0;
! 	attr_buf.data[0] = '\0';
! 	attr_buf.cursor = 0;
  
! 	enlargeStringInfo(&attr_buf, fld_size);
  
! 	CopyGetData(attr_buf.data, fld_size);
  	if (CopyGetEof())
  		ereport(ERROR,
  				(errcode(ERRCODE_BAD_COPY_FILE_FORMAT),
  				 errmsg("unexpected EOF in COPY data")));
  
! 	attr_buf.len = fld_size;
! 	attr_buf.data[fld_size] = '\0';
  
! 	/*
! 	 * Call the column type's binary input converter 
! 	 */
  	result = FunctionCall2(flinfo,
! 						   PointerGetDatum(&attr_buf),
  						   ObjectIdGetDatum(typioparam));
  
! 	/*
! 	 * Trouble if it didn't eat the whole buffer 
! 	 */
! 	if (attr_buf.cursor != attr_buf.len)
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
  				 errmsg("incorrect binary data format")));
***************
*** 2668,2674 ****
  				 */
  				if (!same_encoding)
  				{
! 					/* send additional bytes of the char, if any */
  					mblen = pg_encoding_mblen(client_encoding, string);
  					for (i = 1; i < mblen; i++)
  						CopySendChar(string[i]);
--- 4314,4322 ----
  				 */
  				if (!same_encoding)
  				{
! 					/*
! 					 * send additional bytes of the char, if any
! 					 */
  					mblen = pg_encoding_mblen(client_encoding, string);
  					for (i = 1; i < mblen; i++)
  						CopySendChar(string[i]);
***************
*** 2709,2716 ****
  	 */
  
  	for (test_string = string;
! 		 !use_quote && (c = *test_string) != '\0';
! 		 test_string += mblen)
  	{
  		if (c == delimc || c == quotec || c == '\n' || c == '\r')
  			use_quote = true;
--- 4357,4363 ----
  	 */
  
  	for (test_string = string;
! 		 !use_quote && (c = *test_string) != '\0'; test_string += mblen)
  	{
  		if (c == delimc || c == quotec || c == '\n' || c == '\r')
  			use_quote = true;
